Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp	(revision 51907)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/cfg/VBoxNetCfg.cpp	(revision 51908)
@@ -593,8 +593,8 @@
 
 typedef BOOL (*VBOXNETCFGWIN_NETENUM_CALLBACK) (HDEVINFO hDevInfo, PSP_DEVINFO_DATA pDev, PVOID pContext);
-VBOXNETCFGWIN_DECL(HRESULT) VBoxNetCfgWinEnumNetDevices(LPCWSTR pwszPnPID,
+VBOXNETCFGWIN_DECL(HRESULT) VBoxNetCfgWinEnumNetDevices(LPCWSTR pwszPnPId,
                                                         VBOXNETCFGWIN_NETENUM_CALLBACK callback, PVOID pContext)
 {
-    NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Searching for: %S\n", pwszPnPID));
+    NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Searching for: %S\n", pwszPnPId));
 
     HRESULT hr;
@@ -610,6 +610,6 @@
         DWORD winEr;
 
-        DWORD dwDevID = 0;
-        size_t cPnPId = wcslen(pwszPnPID);
+        DWORD dwDevId = 0;
+        size_t cPnPId = wcslen(pwszPnPId);
 
         PBYTE pBuffer = NULL;
@@ -621,5 +621,5 @@
             Dev.cbSize = sizeof(SP_DEVINFO_DATA);
 
-            if (!SetupDiEnumDeviceInfo(hDevInfo, dwDevID, &Dev))
+            if (!SetupDiEnumDeviceInfo(hDevInfo, dwDevId, &Dev))
             {
                 winEr = GetLastError();
@@ -629,6 +629,6 @@
             }
 
-            NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Enumerating device %ld ... \n", dwDevID));
-            dwDevID++;
+            NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Enumerating device %ld ... \n", dwDevId));
+            dwDevId++;
 
             if (pBuffer)
@@ -677,13 +677,13 @@
             }
 
-            PWSTR pCurID = (PWSTR)pBuffer;
-            size_t cCurId = wcslen(pCurID);
-
-            NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Device %ld: %S\n", dwDevID, pCurID));
+            PWSTR pCurId = (PWSTR)pBuffer;
+            size_t cCurId = wcslen(pCurId);
+
+            NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Device %ld: %S\n", dwDevId, pCurId));
 
             if (cCurId >= cPnPId)
             {
-                pCurID += cCurId - cPnPId;
-                if (!wcsnicmp(pCurID, pwszPnPID, cPnPId))
+                pCurId += cCurId - cPnPId;
+                if (!wcsnicmp(pCurId, pwszPnPId, cPnPId))
                 {
                     if (!callback(hDevInfo, &Dev, pContext))
@@ -693,5 +693,5 @@
         }
 
-        NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Found %ld devices total\n", dwDevID));
+        NonStandardLogFlow(("VBoxNetCfgWinEnumNetDevices: Found %ld devices total\n", dwDevId));
 
         if (pBuffer)
@@ -2549,10 +2549,10 @@
                     {
                           /* get the device instance ID */
-                          TCHAR devID [MAX_DEVICE_ID_LEN];
+                          TCHAR devId[MAX_DEVICE_ID_LEN];
                           if (CM_Get_Device_ID(DeviceInfoData.DevInst,
-                                               devID, MAX_DEVICE_ID_LEN, 0) == CR_SUCCESS)
+                                               devId, MAX_DEVICE_ID_LEN, 0) == CR_SUCCESS)
                           {
                               /* compare to what we determined before */
-                              if (wcscmp(devID, lszPnPInstanceId) == 0)
+                              if (wcscmp(devId, lszPnPInstanceId) == 0)
                               {
                                   found = TRUE;
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/tools/VBoxNetFltUninstall.cpp
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/tools/VBoxNetFltUninstall.cpp	(revision 51907)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/tools/VBoxNetFltUninstall.cpp	(revision 51908)
@@ -48,5 +48,5 @@
             {
                 hr = VBoxNetCfgWinNetFltUninstall(pnc);
-                if(hr != S_OK)
+                if(hr != S_OK && hr != S_FALSE)
                 {
                     wprintf(L"error uninstalling VBoxNetFlt (0x%x)\n", hr);